//---------------------------------------------------------------------------
#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <vcl\StdCtrls.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Classes.hpp>
#include "Ttcpsock.h"
//---------------------------------------------------------------------------
class TConnections
{
public:
	TConnections( TComponent* Owner){
		tcp = new TTcpSock( Owner);
		count++;
		next=0;
    welcomed=false;
	}
	~TConnections(){
		delete tcp;
		count--;
  }
	TTcpSock *tcp;
	static int count;
  bool welcomed;
  TConnections *next;
};
//---------------------------------------------------------------------------
class TServerForm : public TForm
{
__published:	// IDE-managed Components
	TEdit *State;
	TEdit *Connections;
	TEdit *Errors;
  TMemo *Memo1;
  TEdit *LocalHost;
	TTcpSock *TCP1;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall TCP1ConnectRequest(TObject *Sender, TSocket requestID);
	void __fastcall FormDestroy(TObject *Sender);
private:	// User declarations
	TConnections *cList;
	void __fastcall tcpConnectionClosing(TObject *Sender);
  TConnections* GetConnection(TObject *Sender);
  void __fastcall tcpDataReceived(TObject *Sender);
  void __fastcall tcpWriteComplete(TObject *Sender);
  void __fastcall tcpError(TObject *Sender);
public:		// User declarations
	__fastcall TServerForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern TServerForm *ServerForm;
//---------------------------------------------------------------------------
#endif
