//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "main.h"
//---------------------------------------------------------------------------
#pragma link "ttcpsock"
#pragma resource "*.dfm"
TClientForm *ClientForm;
//---------------------------------------------------------------------------
__fastcall TClientForm::TClientForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TClientForm::ConnectButtonClick(TObject *Sender)
{
	if( ConnectButton->Caption == "&Connect"){
		TCP1->RemotePort = Port->Text.ToInt();
		TCP1->RemoteHost = Host->Text;
	  TCP1->Connect();
  	ConnectButton->Caption = "&Cancel";
	  State->Text = "Socket Open.";
	}else{
		TCP1->Close();
		ConnectButton->Caption = "&Connect";
		State->Text = "Socket Closed.";
	}
}
//---------------------------------------------------------------------------
void __fastcall TClientForm::TCP1Close(TObject *Sender)
{
	ConnectButtonClick(0);
}
//---------------------------------------------------------------------------
void __fastcall TClientForm::TCP1Connect(TObject *Sender)
{
  State->Text = "Socket Connected.";
}
//---------------------------------------------------------------------------
void __fastcall TClientForm::TCP1DataReceived(TObject *Sender)
{
  const int buf_len = 80;
  char buf[ buf_len];
  int n = TCP1->Read( buf, buf_len);

  buf[n] = 0; //null terminate received string
  Memo1->Lines->Add( AnsiString(buf));
}
//---------------------------------------------------------------------------
void __fastcall TClientForm::CBAutoClick(TObject *Sender)
{
  Timer1->Enabled = CBAuto->Checked;  
}
//---------------------------------------------------------------------------
void __fastcall TClientForm::Timer1Timer(TObject *Sender)
{
  Timer1->Interval = 100 + random( 2000);
  ConnectButtonClick(0);  
}
//---------------------------------------------------------------------------
